--- src/uri.c.orig	2016-03-24 09:04:32.000000000 -0700
+++ src/uri.c	2016-03-24 09:11:25.000000000 -0700
@@ -26,6 +26,34 @@
 #define TRUE 1
 #endif
 
+#ifdef __APPLE__
+#include <Availability.h>
+#if __MAC_OS_X_VERSION_MIN_REQUIRED <= 1060
+static char * strndup (char const *s, size_t n);
+static size_t strnlen (const char *string, size_t maxlen);
+
+static size_t
+strnlen (const char *string, size_t maxlen)
+{
+  const char *end = memchr (string, '\0', maxlen);
+  return end ? (size_t) (end - string) : maxlen;
+}
+
+static char *
+strndup (char const *s, size_t n)
+{
+  size_t len = strnlen (s, n);
+  char *new = malloc (len + 1);
+
+  if (new == NULL)
+    return NULL;
+
+  new[len] = '\0';
+  return memcpy (new, s, len);
+}
+#endif
+#endif
+
 #define g_strdup strdup
 #define g_strndup strndup
 #define g_malloc malloc
